/* ============================================================================== 
 * Copyright (c) 2013 Pengchong Jin (Purdue University)
 * Copyright (c) 2013 S. Jordan Kisner (Purdue University)
 * Copyright (c) 2013 Thomas Frese
 * Copyright (c) 2013 Charles A. Bouman (Purdue University)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this
 * list of conditions and the following disclaimer in the documentation and/or
 * other materials provided with the distribution.
 *
 * Neither the name of Pengchong Jin, S. J. Kisner, Thomas Frese, Charles A. Bouman
 * Purdue University, nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ============================================================================== */

#ifndef _ACOMP_H_
#define _ACOMP_H_

/* make these odd number so that we have samples in the center */
#define LEN_PIX 511
#define LEN_DET 101

void pix_prof_comp(struct SinoInfo *sino_info, struct ImgInfo *img_info, ENTRY ***pix_prof);
void A_comp(int im_row, int im_col, struct SinoInfo *sino_info, struct ImgInfo *img_info, ENTRY **pix_prof, struct ACol *A_col);
void readAmatrix(char *fname, struct ACol **A_col_arr, struct ImgInfo *img_info);
void writeAmatrix(char *fname, struct ACol **A_col_arr, struct ImgInfo *img_info);

#endif
