/* ============================================================================== 
 * Copyright (c) 2013 Pengchong Jin (Purdue University)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this
 * list of conditions and the following disclaimer in the documentation and/or
 * other materials provided with the distribution.
 *
 * Neither the name of Pengchong Jin, Purdue University,
 * nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ============================================================================== */

#ifndef _IO2D_H_
#define _IO2D_H_

void readImgInfo(char *fname, struct ImgInfo *img_info);
void printImgInfo(struct ImgInfo *img_info);
void initializeImage(struct SinoInfo *sino_info, struct Image *image);
void writeImage(char *fname, struct Image *image);
void freeImage(struct Image *image);
void readSinoInfo(char *fname, struct SinoInfo *sino_info);
void printSinoInfo(struct SinoInfo *sino_info);
void readSinogram(char *fname, struct Sinogram *sinogram);
void writeSinogram(char *fname, struct Sinogram *sinogram);
void freeSinogram(struct Sinogram *sinogram);
void readPriorInfo(char *fname, struct PriorInfo *prior_info);
void printPriorInfo(struct PriorInfo *prior_info, ENTRY mu_water);
void usage(char *fname);
void readData(int argc, char *argv[], struct Image *image, struct Sinogram *sinogram, struct PriorInfo *prior_info);
void freeData(struct Image *image, struct Sinogram *sinogram);

#endif
